# include <p8q.h>

uint32_t
leftRotate(uint32_t val, int amount)
{
  uint32_t r = (val << amount) | (val >> (32 - amount));
  return r;
}

uint32_t
rightRotate(uint32_t val, int amount)
{
  uint32_t r = (val >> amount) | (val << (32 - amount));
  return r;
}

uint32_t
rightShift(uint32_t val, int amount)
{
  uint32_t r = (val >> amount);
  return r;
}

uint32_t
bit(uint32_t x, int i)
{
  return (x & (1 << i)) >> i;
}

int
main(void)
{
  int a = read_public_int(0, 0x7FFFFFFF);
  // int b = leftRotate(a, 4);
  // int c = rightShift(b, 4);
  // assert ( a == c );
  int d = a;
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  d = leftRotate(d, 30);
  assert ( a == d );
  return 0;
}
