{ stdenv, fetchgit, which, coq, bignums }:

stdenv.mkDerivation {

  name = "coq${coq.coq-version}-ppsimpl-8.9";

  src = fetchgit {
    url = https://gforge.inria.fr/git/ppsimpl/ppsimpl.git;
    rev = "beb28cd49a4b5fdd46f08213ad4597c6d13de639";
    sha256 = "06dix9nhk1d0h5227nz41qph2d1r1s7ca45nzs59zyyf663xhxjc";
  };

  buildInputs = [ which coq bignums ]
  ++ (with coq.ocamlPackages; [ ocaml findlib camlp5 ]);

  installFlags = "COQLIB=$(out)/lib/coq/${coq.coq-version}/";

}
