# include <p8q.h>
# include "sha-library.c"

# if ! defined LENGTH
# define LENGTH 1
# endif /* ! defined LENGTH */

int
main(void)
{
  int input[LENGTH];
  for ( int i = 0; i < LENGTH; ++i )
  {
    verasco_unroll(1);
    input[i] = read_public_int(0, 0x7FFFFFFF);
  }
  int size = sizeof(input);
  struct shaOutput output;
  sha1n_lib(&size, (void*)&input, &output);
  for (int i = 0; i < sizeof(output.h) / sizeof(output.h[0]); ++i)
  {
    write_int ( output.h[i] );
  }
  return 0;
}
